/* WindowPositioner.c generated by valac 0.56.17, the Vala compiler
 * generated from WindowPositioner.vala, do not modify */

/*
 * Copyright 2024 elementary, Inc. (https://elementary.io)
 * SPDX-License-Identifier: GPL-3.0-or-later
 *
 * Authored by: Leonhard Kargl <leo.kargl@proton.me>
 */

#include <glib-object.h>
#include <meta/display.h>
#include <meta/window.h>
#include <glib.h>
#include "pantheon-desktop-shell-server-protocol.h"
#include <stdlib.h>
#include <string.h>
#include <mtk/mtk.h>
#include <meta/meta-monitor-manager.h>
#include <meta/meta-context.h>
#include <meta/meta-backend.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define GALA_TYPE_WINDOW_POSITIONER (gala_window_positioner_get_type ())
#define GALA_WINDOW_POSITIONER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GALA_TYPE_WINDOW_POSITIONER, GalaWindowPositioner))
#define GALA_WINDOW_POSITIONER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GALA_TYPE_WINDOW_POSITIONER, GalaWindowPositionerClass))
#define GALA_IS_WINDOW_POSITIONER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GALA_TYPE_WINDOW_POSITIONER))
#define GALA_IS_WINDOW_POSITIONER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GALA_TYPE_WINDOW_POSITIONER))
#define GALA_WINDOW_POSITIONER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GALA_TYPE_WINDOW_POSITIONER, GalaWindowPositionerClass))

typedef struct _GalaWindowPositioner GalaWindowPositioner;
typedef struct _GalaWindowPositionerClass GalaWindowPositionerClass;
typedef struct _GalaWindowPositionerPrivate GalaWindowPositionerPrivate;
typedef enum  {
	GALA_WINDOW_POSITIONER_POSITION_TOP,
	GALA_WINDOW_POSITIONER_POSITION_BOTTOM,
	GALA_WINDOW_POSITIONER_POSITION_CENTER
} GalaWindowPositionerPosition;

#define GALA_WINDOW_POSITIONER_TYPE_POSITION (gala_window_positioner_position_get_type ())
enum  {
	GALA_WINDOW_POSITIONER_0_PROPERTY,
	GALA_WINDOW_POSITIONER_DISPLAY_PROPERTY,
	GALA_WINDOW_POSITIONER_WINDOW_PROPERTY,
	GALA_WINDOW_POSITIONER_POSITION_PROPERTY,
	GALA_WINDOW_POSITIONER_POSITION_DATA_PROPERTY,
	GALA_WINDOW_POSITIONER_NUM_PROPERTIES
};
static GParamSpec* gala_window_positioner_properties[GALA_WINDOW_POSITIONER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))

struct _GalaWindowPositioner {
	GObject parent_instance;
	GalaWindowPositionerPrivate * priv;
};

struct _GalaWindowPositionerClass {
	GObjectClass parent_class;
};

struct _GalaWindowPositionerPrivate {
	MetaDisplay* _display;
	MetaWindow* _window;
	GalaWindowPositionerPosition _position;
	GVariant* _position_data;
};

static gint GalaWindowPositioner_private_offset;
static gpointer gala_window_positioner_parent_class = NULL;

VALA_EXTERN GType gala_window_positioner_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GalaWindowPositioner, g_object_unref)
VALA_EXTERN GType gala_window_positioner_position_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GalaWindowPositionerPosition gala_window_positioner_position_from_anchor (enum io_elementary_pantheon_panel_v1_anchor anchor);
static const char* _pantheon_desktop_anchor_to_string (enum io_elementary_pantheon_panel_v1_anchor value);
VALA_EXTERN GalaWindowPositioner* gala_window_positioner_new (MetaDisplay* display,
                                                  MetaWindow* window,
                                                  GalaWindowPositionerPosition position,
                                                  GVariant* position_data);
VALA_EXTERN GalaWindowPositioner* gala_window_positioner_construct (GType object_type,
                                                        MetaDisplay* display,
                                                        MetaWindow* window,
                                                        GalaWindowPositionerPosition position,
                                                        GVariant* position_data);
static void gala_window_positioner_position_window (GalaWindowPositioner* self);
VALA_EXTERN MetaWindow* gala_window_positioner_get_window (GalaWindowPositioner* self);
VALA_EXTERN GalaWindowPositionerPosition gala_window_positioner_get_position (GalaWindowPositioner* self);
VALA_EXTERN MetaDisplay* gala_window_positioner_get_display (GalaWindowPositioner* self);
static void gala_window_positioner_set_display (GalaWindowPositioner* self,
                                         MetaDisplay* value);
static void gala_window_positioner_set_window (GalaWindowPositioner* self,
                                        MetaWindow* value);
VALA_EXTERN void gala_window_positioner_set_position (GalaWindowPositioner* self,
                                          GalaWindowPositionerPosition value);
VALA_EXTERN GVariant* gala_window_positioner_get_position_data (GalaWindowPositioner* self);
VALA_EXTERN void gala_window_positioner_set_position_data (GalaWindowPositioner* self,
                                               GVariant* value);
static GObject * gala_window_positioner_constructor (GType type,
                                              guint n_construct_properties,
                                              GObjectConstructParam * construct_properties);
static void _gala_window_positioner_position_window_meta_window_size_changed (MetaWindow* _sender,
                                                                       gpointer self);
static void _gala_window_positioner_position_window_meta_window_position_changed (MetaWindow* _sender,
                                                                           gpointer self);
static void _gala_window_positioner_position_window_meta_window_shown (MetaWindow* _sender,
                                                                gpointer self);
static void _gala_window_positioner_position_window_meta_monitor_manager_monitors_changed (MetaMonitorManager* _sender,
                                                                                    gpointer self);
static void _gala_window_positioner_position_window_meta_monitor_manager_monitors_changed_internal (MetaMonitorManager* _sender,
                                                                                             gpointer self);
static void _gala_window_positioner_position_window_g_object_notify (GObject* _sender,
                                                              GParamSpec* pspec,
                                                              gpointer self);
static void gala_window_positioner_finalize (GObject * obj);
static GType gala_window_positioner_get_type_once (void);
static void _vala_gala_window_positioner_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_gala_window_positioner_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);

static inline gpointer
gala_window_positioner_get_instance_private (GalaWindowPositioner* self)
{
	return G_STRUCT_MEMBER_P (self, GalaWindowPositioner_private_offset);
}

static const char*
_pantheon_desktop_anchor_to_string (enum io_elementary_pantheon_panel_v1_anchor value)
{
	switch (value) {
		case IO_ELEMENTARY_PANTHEON_PANEL_V1_ANCHOR_TOP:
		return "IO_ELEMENTARY_PANTHEON_PANEL_V1_ANCHOR_TOP";
		case IO_ELEMENTARY_PANTHEON_PANEL_V1_ANCHOR_BOTTOM:
		return "IO_ELEMENTARY_PANTHEON_PANEL_V1_ANCHOR_BOTTOM";
		case IO_ELEMENTARY_PANTHEON_PANEL_V1_ANCHOR_LEFT:
		return "IO_ELEMENTARY_PANTHEON_PANEL_V1_ANCHOR_LEFT";
		case IO_ELEMENTARY_PANTHEON_PANEL_V1_ANCHOR_RIGHT:
		return "IO_ELEMENTARY_PANTHEON_PANEL_V1_ANCHOR_RIGHT";
	}
	return NULL;
}

GalaWindowPositionerPosition
gala_window_positioner_position_from_anchor (enum io_elementary_pantheon_panel_v1_anchor anchor)
{
	GalaWindowPositionerPosition result;
	if (anchor > 1) {
		const gchar* _tmp0_;
		_tmp0_ = _pantheon_desktop_anchor_to_string (anchor);
		g_warning ("WindowPositioner.vala:16: Position %s not supported yet", _tmp0_);
		result = GALA_WINDOW_POSITIONER_POSITION_CENTER;
		return result;
	}
	result = (GalaWindowPositionerPosition) anchor;
	return result;
}

 G_GNUC_NO_INLINE static GType
gala_window_positioner_position_get_type_once (void)
{
	static const GEnumValue values[] = {{GALA_WINDOW_POSITIONER_POSITION_TOP, "GALA_WINDOW_POSITIONER_POSITION_TOP", "top"}, {GALA_WINDOW_POSITIONER_POSITION_BOTTOM, "GALA_WINDOW_POSITIONER_POSITION_BOTTOM", "bottom"}, {GALA_WINDOW_POSITIONER_POSITION_CENTER, "GALA_WINDOW_POSITIONER_POSITION_CENTER", "center"}, {0, NULL, NULL}};
	GType gala_window_positioner_position_type_id;
	gala_window_positioner_position_type_id = g_enum_register_static ("GalaWindowPositionerPosition", values);
	return gala_window_positioner_position_type_id;
}

GType
gala_window_positioner_position_get_type (void)
{
	static gsize gala_window_positioner_position_type_id__once = 0;
	if (g_once_init_enter (&gala_window_positioner_position_type_id__once)) {
		GType gala_window_positioner_position_type_id;
		gala_window_positioner_position_type_id = gala_window_positioner_position_get_type_once ();
		g_once_init_leave (&gala_window_positioner_position_type_id__once, gala_window_positioner_position_type_id);
	}
	return gala_window_positioner_position_type_id__once;
}

GalaWindowPositioner*
gala_window_positioner_construct (GType object_type,
                                  MetaDisplay* display,
                                  MetaWindow* window,
                                  GalaWindowPositionerPosition position,
                                  GVariant* position_data)
{
	GalaWindowPositioner * self = NULL;
	g_return_val_if_fail (display != NULL, NULL);
	g_return_val_if_fail (window != NULL, NULL);
	self = (GalaWindowPositioner*) g_object_new (object_type, "display", display, "window", window, "position", position, "position-data", position_data, NULL);
	return self;
}

GalaWindowPositioner*
gala_window_positioner_new (MetaDisplay* display,
                            MetaWindow* window,
                            GalaWindowPositionerPosition position,
                            GVariant* position_data)
{
	return gala_window_positioner_construct (GALA_TYPE_WINDOW_POSITIONER, display, window, position, position_data);
}

static void
gala_window_positioner_position_window (GalaWindowPositioner* self)
{
	gint x = 0;
	gint y = 0;
	MtkRectangle window_rect = {0};
	MetaWindow* _tmp0_;
	MtkRectangle _tmp1_ = {0};
	GalaWindowPositionerPosition _tmp2_;
	MetaWindow* _tmp28_;
	g_return_if_fail (self != NULL);
	x = 0;
	y = 0;
	_tmp0_ = self->priv->_window;
	meta_window_get_frame_rect (_tmp0_, &_tmp1_);
	window_rect = _tmp1_;
	_tmp2_ = self->priv->_position;
	switch (_tmp2_) {
		case GALA_WINDOW_POSITIONER_POSITION_CENTER:
		{
			MtkRectangle monitor_geom = {0};
			MetaDisplay* _tmp3_;
			MetaDisplay* _tmp4_;
			MtkRectangle _tmp5_ = {0};
			MtkRectangle _tmp6_;
			MtkRectangle _tmp7_;
			MtkRectangle _tmp8_;
			MtkRectangle _tmp9_;
			MtkRectangle _tmp10_;
			MtkRectangle _tmp11_;
			_tmp3_ = self->priv->_display;
			_tmp4_ = self->priv->_display;
			meta_display_get_monitor_geometry (_tmp3_, meta_display_get_primary_monitor (_tmp4_), &_tmp5_);
			monitor_geom = _tmp5_;
			_tmp6_ = monitor_geom;
			_tmp7_ = monitor_geom;
			_tmp8_ = window_rect;
			x = _tmp6_.x + ((_tmp7_.width - _tmp8_.width) / 2);
			_tmp9_ = monitor_geom;
			_tmp10_ = monitor_geom;
			_tmp11_ = window_rect;
			y = _tmp9_.y + ((_tmp10_.height - _tmp11_.height) / 2);
			break;
		}
		case GALA_WINDOW_POSITIONER_POSITION_TOP:
		{
			MtkRectangle monitor_geom = {0};
			MetaDisplay* _tmp12_;
			MetaDisplay* _tmp13_;
			MtkRectangle _tmp14_ = {0};
			MtkRectangle _tmp15_;
			MtkRectangle _tmp16_;
			MtkRectangle _tmp17_;
			MtkRectangle _tmp18_;
			_tmp12_ = self->priv->_display;
			_tmp13_ = self->priv->_display;
			meta_display_get_monitor_geometry (_tmp12_, meta_display_get_primary_monitor (_tmp13_), &_tmp14_);
			monitor_geom = _tmp14_;
			_tmp15_ = monitor_geom;
			_tmp16_ = monitor_geom;
			_tmp17_ = window_rect;
			x = _tmp15_.x + ((_tmp16_.width - _tmp17_.width) / 2);
			_tmp18_ = monitor_geom;
			y = _tmp18_.y;
			break;
		}
		case GALA_WINDOW_POSITIONER_POSITION_BOTTOM:
		{
			MtkRectangle monitor_geom = {0};
			MetaDisplay* _tmp19_;
			MetaDisplay* _tmp20_;
			MtkRectangle _tmp21_ = {0};
			MtkRectangle _tmp22_;
			MtkRectangle _tmp23_;
			MtkRectangle _tmp24_;
			MtkRectangle _tmp25_;
			MtkRectangle _tmp26_;
			MtkRectangle _tmp27_;
			_tmp19_ = self->priv->_display;
			_tmp20_ = self->priv->_display;
			meta_display_get_monitor_geometry (_tmp19_, meta_display_get_primary_monitor (_tmp20_), &_tmp21_);
			monitor_geom = _tmp21_;
			_tmp22_ = monitor_geom;
			_tmp23_ = monitor_geom;
			_tmp24_ = window_rect;
			x = _tmp22_.x + ((_tmp23_.width - _tmp24_.width) / 2);
			_tmp25_ = monitor_geom;
			_tmp26_ = monitor_geom;
			_tmp27_ = window_rect;
			y = (_tmp25_.y + _tmp26_.height) - _tmp27_.height;
			break;
		}
		default:
		break;
	}
	_tmp28_ = self->priv->_window;
	meta_window_move_frame (_tmp28_, FALSE, x, y);
}

MetaDisplay*
gala_window_positioner_get_display (GalaWindowPositioner* self)
{
	MetaDisplay* result;
	MetaDisplay* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_display;
	result = _tmp0_;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
gala_window_positioner_set_display (GalaWindowPositioner* self,
                                    MetaDisplay* value)
{
	MetaDisplay* old_value;
	g_return_if_fail (self != NULL);
	old_value = gala_window_positioner_get_display (self);
	if (old_value != value) {
		MetaDisplay* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_display);
		self->priv->_display = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, gala_window_positioner_properties[GALA_WINDOW_POSITIONER_DISPLAY_PROPERTY]);
	}
}

MetaWindow*
gala_window_positioner_get_window (GalaWindowPositioner* self)
{
	MetaWindow* result;
	MetaWindow* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_window;
	result = _tmp0_;
	return result;
}

static void
gala_window_positioner_set_window (GalaWindowPositioner* self,
                                   MetaWindow* value)
{
	MetaWindow* old_value;
	g_return_if_fail (self != NULL);
	old_value = gala_window_positioner_get_window (self);
	if (old_value != value) {
		MetaWindow* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_window);
		self->priv->_window = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, gala_window_positioner_properties[GALA_WINDOW_POSITIONER_WINDOW_PROPERTY]);
	}
}

GalaWindowPositionerPosition
gala_window_positioner_get_position (GalaWindowPositioner* self)
{
	GalaWindowPositionerPosition result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_position;
	return result;
}

void
gala_window_positioner_set_position (GalaWindowPositioner* self,
                                     GalaWindowPositionerPosition value)
{
	GalaWindowPositionerPosition old_value;
	g_return_if_fail (self != NULL);
	old_value = gala_window_positioner_get_position (self);
	if (old_value != value) {
		self->priv->_position = value;
		g_object_notify_by_pspec ((GObject *) self, gala_window_positioner_properties[GALA_WINDOW_POSITIONER_POSITION_PROPERTY]);
	}
}

GVariant*
gala_window_positioner_get_position_data (GalaWindowPositioner* self)
{
	GVariant* result;
	GVariant* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_position_data;
	result = _tmp0_;
	return result;
}

static gpointer
_g_variant_ref0 (gpointer self)
{
	return self ? g_variant_ref (self) : NULL;
}

void
gala_window_positioner_set_position_data (GalaWindowPositioner* self,
                                          GVariant* value)
{
	GVariant* old_value;
	g_return_if_fail (self != NULL);
	old_value = gala_window_positioner_get_position_data (self);
	if (old_value != value) {
		GVariant* _tmp0_;
		_tmp0_ = _g_variant_ref0 (value);
		_g_variant_unref0 (self->priv->_position_data);
		self->priv->_position_data = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, gala_window_positioner_properties[GALA_WINDOW_POSITIONER_POSITION_DATA_PROPERTY]);
	}
}

static void
_gala_window_positioner_position_window_meta_window_size_changed (MetaWindow* _sender,
                                                                  gpointer self)
{
	gala_window_positioner_position_window ((GalaWindowPositioner*) self);
}

static void
_gala_window_positioner_position_window_meta_window_position_changed (MetaWindow* _sender,
                                                                      gpointer self)
{
	gala_window_positioner_position_window ((GalaWindowPositioner*) self);
}

static void
_gala_window_positioner_position_window_meta_window_shown (MetaWindow* _sender,
                                                           gpointer self)
{
	gala_window_positioner_position_window ((GalaWindowPositioner*) self);
}

static void
_gala_window_positioner_position_window_meta_monitor_manager_monitors_changed (MetaMonitorManager* _sender,
                                                                               gpointer self)
{
	gala_window_positioner_position_window ((GalaWindowPositioner*) self);
}

static void
_gala_window_positioner_position_window_meta_monitor_manager_monitors_changed_internal (MetaMonitorManager* _sender,
                                                                                        gpointer self)
{
	gala_window_positioner_position_window ((GalaWindowPositioner*) self);
}

static void
_gala_window_positioner_position_window_g_object_notify (GObject* _sender,
                                                         GParamSpec* pspec,
                                                         gpointer self)
{
	gala_window_positioner_position_window ((GalaWindowPositioner*) self);
}

static GObject *
gala_window_positioner_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GalaWindowPositioner * self;
	MetaWindow* _tmp0_;
	MetaWindow* _tmp1_;
	MetaWindow* _tmp2_;
	MetaWindow* _tmp3_;
	MetaMonitorManager* monitor_manager = NULL;
	MetaDisplay* _tmp4_;
	MetaContext* _tmp5_;
	MetaBackend* _tmp6_;
	MetaMonitorManager* _tmp7_;
	MetaMonitorManager* _tmp8_;
	MetaMonitorManager* _tmp9_;
	parent_class = G_OBJECT_CLASS (gala_window_positioner_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_WINDOW_POSITIONER, GalaWindowPositioner);
	_tmp0_ = self->priv->_window;
	meta_window_stick (_tmp0_);
	_tmp1_ = self->priv->_window;
	g_signal_connect_object (_tmp1_, "size-changed", (GCallback) _gala_window_positioner_position_window_meta_window_size_changed, self, 0);
	_tmp2_ = self->priv->_window;
	g_signal_connect_object (_tmp2_, "position-changed", (GCallback) _gala_window_positioner_position_window_meta_window_position_changed, self, 0);
	_tmp3_ = self->priv->_window;
	g_signal_connect_object (_tmp3_, "shown", (GCallback) _gala_window_positioner_position_window_meta_window_shown, self, 0);
	_tmp4_ = self->priv->_display;
	_tmp5_ = meta_display_get_context (_tmp4_);
	_tmp6_ = meta_context_get_backend (_tmp5_);
	_tmp7_ = meta_backend_get_monitor_manager (_tmp6_);
	monitor_manager = _tmp7_;
	_tmp8_ = monitor_manager;
	g_signal_connect_object (_tmp8_, "monitors-changed", (GCallback) _gala_window_positioner_position_window_meta_monitor_manager_monitors_changed, self, 0);
	_tmp9_ = monitor_manager;
	g_signal_connect_object (_tmp9_, "monitors-changed-internal", (GCallback) _gala_window_positioner_position_window_meta_monitor_manager_monitors_changed_internal, self, 0);
	g_signal_connect_object ((GObject*) self, "notify::position", (GCallback) _gala_window_positioner_position_window_g_object_notify, self, 0);
	g_signal_connect_object ((GObject*) self, "notify::position-data", (GCallback) _gala_window_positioner_position_window_g_object_notify, self, 0);
	return obj;
}

static void
gala_window_positioner_class_init (GalaWindowPositionerClass * klass,
                                   gpointer klass_data)
{
	gala_window_positioner_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &GalaWindowPositioner_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_gala_window_positioner_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_gala_window_positioner_set_property;
	G_OBJECT_CLASS (klass)->constructor = gala_window_positioner_constructor;
	G_OBJECT_CLASS (klass)->finalize = gala_window_positioner_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_WINDOW_POSITIONER_DISPLAY_PROPERTY, gala_window_positioner_properties[GALA_WINDOW_POSITIONER_DISPLAY_PROPERTY] = g_param_spec_object ("display", "display", "display", meta_display_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_WINDOW_POSITIONER_WINDOW_PROPERTY, gala_window_positioner_properties[GALA_WINDOW_POSITIONER_WINDOW_PROPERTY] = g_param_spec_object ("window", "window", "window", meta_window_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	/**
	     * This may only be set after the window was shown.
	     * The initial position should only be given in the constructor.
	     */
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_WINDOW_POSITIONER_POSITION_PROPERTY, gala_window_positioner_properties[GALA_WINDOW_POSITIONER_POSITION_PROPERTY] = g_param_spec_enum ("position", "position", "position", GALA_WINDOW_POSITIONER_TYPE_POSITION, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_WINDOW_POSITIONER_POSITION_DATA_PROPERTY, gala_window_positioner_properties[GALA_WINDOW_POSITIONER_POSITION_DATA_PROPERTY] = g_param_spec_variant ("position-data", "position-data", "position-data", G_VARIANT_TYPE_ANY, NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
}

static void
gala_window_positioner_instance_init (GalaWindowPositioner * self,
                                      gpointer klass)
{
	self->priv = gala_window_positioner_get_instance_private (self);
}

static void
gala_window_positioner_finalize (GObject * obj)
{
	GalaWindowPositioner * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_TYPE_WINDOW_POSITIONER, GalaWindowPositioner);
	_g_object_unref0 (self->priv->_display);
	_g_object_unref0 (self->priv->_window);
	_g_variant_unref0 (self->priv->_position_data);
	G_OBJECT_CLASS (gala_window_positioner_parent_class)->finalize (obj);
}

 G_GNUC_NO_INLINE static GType
gala_window_positioner_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GalaWindowPositionerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_window_positioner_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaWindowPositioner), 0, (GInstanceInitFunc) gala_window_positioner_instance_init, NULL };
	GType gala_window_positioner_type_id;
	gala_window_positioner_type_id = g_type_register_static (G_TYPE_OBJECT, "GalaWindowPositioner", &g_define_type_info, 0);
	GalaWindowPositioner_private_offset = g_type_add_instance_private (gala_window_positioner_type_id, sizeof (GalaWindowPositionerPrivate));
	return gala_window_positioner_type_id;
}

GType
gala_window_positioner_get_type (void)
{
	static gsize gala_window_positioner_type_id__once = 0;
	if (g_once_init_enter (&gala_window_positioner_type_id__once)) {
		GType gala_window_positioner_type_id;
		gala_window_positioner_type_id = gala_window_positioner_get_type_once ();
		g_once_init_leave (&gala_window_positioner_type_id__once, gala_window_positioner_type_id);
	}
	return gala_window_positioner_type_id__once;
}

static void
_vala_gala_window_positioner_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	GalaWindowPositioner * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_WINDOW_POSITIONER, GalaWindowPositioner);
	switch (property_id) {
		case GALA_WINDOW_POSITIONER_DISPLAY_PROPERTY:
		g_value_set_object (value, gala_window_positioner_get_display (self));
		break;
		case GALA_WINDOW_POSITIONER_WINDOW_PROPERTY:
		g_value_set_object (value, gala_window_positioner_get_window (self));
		break;
		case GALA_WINDOW_POSITIONER_POSITION_PROPERTY:
		g_value_set_enum (value, gala_window_positioner_get_position (self));
		break;
		case GALA_WINDOW_POSITIONER_POSITION_DATA_PROPERTY:
		g_value_set_variant (value, gala_window_positioner_get_position_data (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_gala_window_positioner_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	GalaWindowPositioner * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_TYPE_WINDOW_POSITIONER, GalaWindowPositioner);
	switch (property_id) {
		case GALA_WINDOW_POSITIONER_DISPLAY_PROPERTY:
		gala_window_positioner_set_display (self, g_value_get_object (value));
		break;
		case GALA_WINDOW_POSITIONER_WINDOW_PROPERTY:
		gala_window_positioner_set_window (self, g_value_get_object (value));
		break;
		case GALA_WINDOW_POSITIONER_POSITION_PROPERTY:
		gala_window_positioner_set_position (self, g_value_get_enum (value));
		break;
		case GALA_WINDOW_POSITIONER_POSITION_DATA_PROPERTY:
		gala_window_positioner_set_position_data (self, g_value_get_variant (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

